#!/usr/bin/env python

"""
  to test with python

cmd1:env keystore=`pwd` ./query.py 
cmd2: env ABAC_CN=1 keystore=`pwd` ./query.py

"""

import os
import ABAC

ctxt = ABAC.Context()

# print "ABAC version %s" % ctxt.version()

keystore=os.environ["keystore"]

ctxt.load_directory(keystore)

acmeID=ABAC.ID("Acme_ID.pem");
acmeID.id_load_privkey_file("Acme_private.pem");
acme=acmeID.id_keyid()

bobID=ABAC.ID("Bob_ID.pem");
bobID.id_load_privkey_file("Bob_private.pem");
bob=bobID.id_keyid()

aliceID=ABAC.ID("Alice_ID.pem");
aliceID.id_load_privkey_file("Alice_private.pem");
alice=aliceID.id_keyid()

globotronID=ABAC.ID("Globotron_ID.pem");
globotronID.id_load_privkey_file("Globotron_private.pem");
globotron=globotronID.id_keyid()

##########################################################################
# role=[keyid:Globotron].role:admin 
# p=[keyid:Alice]
role = ABAC.Role(globotron,"admin")
p = ABAC.Role(alice)
print "\n===good=============== Globotron.admin <- Alice"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())

##########################################################################
# role=[keyid:Globotron].role:admin 
# p=[keyid:Bob]
role = ABAC.Role(globotron,"admin")
p = ABAC.Role(bob)
print "\n===bad=============== Globotron.admin <- Bob"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())


##########################################################################
# role=[keyid:Acme].role:experiment_create 
# p=[keyid:Bob]
role = ABAC.Role(acme,"experiment_create")
p = ABAC.Role(bob)
print "\n===good=============== Acme.experiment_create <- Bob"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())


##########################################################################
# dump the loaded principals/policies
#
out = ctxt.context_principals()
print "\n...final principal set..."
for x in out[1]:
    print "%s " % x.string()
print "\n"
out = ctxt.context_credentials()
print "\n...final policy attribute set..."
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())
print "\n"


